%define oname GMetrics
%define with_gmaven 1
Name:          gmetrics
Version:       0.3
Release:       %mkrel 3
Summary:       Groovy library that provides reports and metrics for Groovy code
Group:         Development/Java
License:       ASL 2.0
Url:           http://gmetrics.sourceforge.net/
Source0:       http://sourceforge.net/projects/gmetrics/files/gmerics-0.3/GMetrics-0.3-bin.tar.gz
# from debian
Source1:       gmetrics-0.3-build.xml
Source2:       gmetrics-0.3-build.properties
# http://bugs.debian.org/613266
Patch0:        gmetrics-0.3-FTBFS.patch

Patch1:        gmetrics-0.3-remove_gmaven.patch

Patch2:        gmetrics-0.3-pom_xml.patch

BuildRequires: java-devel
BuildRequires: jpackage-utils

BuildRequires: ant
BuildRequires: apache-commons-cli
BuildRequires: groovy16
BuildRequires: liblog4j-java
#BuildRequires: asm3
%if %with_gmaven
BuildRequires: gmaven
BuildRequires: gmaven-runtime-1.6
BuildRequires: maven-assembly-plugin
BuildRequires: maven-compiler-plugin
BuildRequires: maven-gpg-plugin
BuildRequires: maven-jar-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-plugin-cobertura
BuildRequires: maven-project-info-reports-plugin
BuildRequires: maven-release-plugin
BuildRequires: maven-resources-plugin
BuildRequires: maven-surefire-plugin
BuildRequires: fusesource-pom
%endif
Requires:      apache-commons-cli
Requires:      groovy16
Requires:      liblog4j-java

#Requires:      asm3

Requires:      jpackage-utils
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:      java
BuildArch:     noarch

%description
GMetrics provides calculation and reporting of size and
complexity metrics for Groovy source code, by scanning the
code with an Ant Task, applying a set of metrics, and
generating an HTML or XML report of the results.

%files
%{_javadir}/%{oname}-%{version}.jar
%{_javadir}/%{oname}.jar
%{_javadir}/%{name}.jar
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}
%doc CHANGELOG.txt LICENSE.txt NOTICE.txt README.txt

#--------------------------------------------------------------------

%package javadoc
Group:         Development/Java
Summary:       Javadoc for %{name}
Requires:      %{name} = %{version}-%{release} 
Requires:      jpackage-utils

%description javadoc
This package contains javadoc for %{name}.

%files javadoc
%{_javadocdir}/%{name}

#--------------------------------------------------------------------

%prep
%setup -q -n %{oname}-%{version}

rm -rf docs/*

for j in $(find . -name "*.jar" -o -name "*.class"); do
  rm -rf $j
done

%if !%with_gmaven
%patch0 -p1
%patch1 -p0
%endif
cp -pr %{SOURCE1} build.xml
cp -pr %{SOURCE2} build.properties
%patch2 -p0

%build
%if %with_gmaven
mvn-rpmbuild -e -Dmaven.test.failure.ignore=true install javadoc:aggregate
export CLASSPATH=$(build-classpath groovy16-all commons-cli log4j.jar )
ant groovydoc
%else
# do nor use asm3
#export CLASSPATH=$(build-classpath groovy commons-cli asm3/ log4j.jar  )
export CLASSPATH=$(build-classpath groovy16-all commons-cli log4j.jar )
ant
%endif

%install
install -d -m 755 %{buildroot}%{_javadir}

%if %with_gmaven
install -pm 644 target/%{oname}-%{version}.jar %{buildroot}%{_javadir}/%{oname}-%{version}.jar
%else
install -pm 644 target/%{oname}.jar %{buildroot}%{_javadir}/%{oname}-%{version}.jar
%endif

(
  cd %{buildroot}%{_javadir}
  for jar in *-%{version}*; do
    ln -s  ${jar} ${jar/-%{version}/};
  done
  ln -sf %{oname}-%{version}.jar %{name}.jar
)

mkdir -p %{buildroot}%{_mavenpomdir}
install -m 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%add_maven_depmap JPP-%{name}.pom %{name}.jar

mkdir -p %{buildroot}%{_javadocdir}/%{name}
cp -pr target/groovydoc/* %{buildroot}%{_javadocdir}/%{name}


%changelog

* Mon Jan 09 2012 gil <gil> 0.3-3.mga2
+ Revision: 193588
- used %%{buildroot} instead of RPM_BUILD_ROOT
- fixed artifacts installation
- rebuilt with gmaven support
  used proper groovy version 1.6.x
  added  maven pom

* Fri Nov 04 2011 dmorgan <dmorgan> 0.3-2.mga2
+ Revision: 162659
- Requires asm3

* Fri Nov 04 2011 dmorgan <dmorgan> 0.3-1.mga2
+ Revision: 162605
- Adapt CLASSPATH
- Clean spec file

  + gil <gil>
    - imported package gmetrics

